#define __LIBRARY__
#include <stdio.h>
#include <string.h>
#include <qdos.h>
#include <sys/socket.h>
#include "qsockets.h"
#include <errno.h>
#include <fcntl.h>

int sendto (int s, const void *b, int ln, unsigned int flag,
            struct sockaddr *sa, int slen)
{
    REGS_t in,out;
    int res;
    long params[2];

    CHECK_SOCKET(s);
    
    params[0] = (long)sa;
    params[1] = (long)slen;
    
    in.D0 = IP_SENDTO;
    in.D1 = flag;
    in.D2 = ln;
    in.D3 = -1;
    in.A0 = (addreg_t)getchid(s);
    in.A1 = (addreg_t)b;
    in.A2 = (addreg_t)params;
    
    res = qdos3(&in, &out);
    if(res < 0)
    {
	switch (res)
        {
            case ERR_NC: errno==EAGAIN; 
                break;
                    /* probably other errors should be handled here */
            default: neterrno(in.A0, res);
        }
        res = -1;
    }
    return res;
}
