#define __LIBRARY__
#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include "qsockets.h"
#include <errno.h>
#include <fcntl.h>
#include <qdos.h>
#include <stdlib.h>
#include <unistd.h>

int neterrno(addreg_t ch, int res)
{
    REGS_t in,out;

    if(res < 0)
    {
        in.D0 = IP_ERRNO;
        in.D3 = -1;
        in.A0 = ch;
        qdos3(&in, &out);
        errno = out.D1;
        res = -1;
    }
    return res;
}


int _socket_fd(int ch, char *dev)
{
    struct UFB *uptr;
    int fd = -1;
    int mode = O_RDWR;
    short   ufbflags;
    
    if ((fd = _Openufb()) >= 0)
    {
        uptr = &_ufbs[fd];
        ufbflags = UFB_OP;          /* Preset open status bit */
        uptr->ufbnam = strdup(dev);
        uptr->ufbfh = uptr->ufbfh1 = ch; /* c68 libc does some wierd things
                                            for D_SOCKET devices !! */
        uptr->ufbtyp = D_SOCKET;
        mode ^= (_iomode & O_RAW);
        ufbflags |= _ModeUfb (mode);
        uptr->ufbflg = ufbflags;
    }
    else fd = -1;
    return fd;
}

int socket(int domain, int type, int protocol)
{
    static const char *ndevs[] = {"tcp_","udp_","uxs_","uxd_"};
    int fd = -1,ch;
 
    if(domain == AF_INET || domain == AF_UNIX)
    {
        if(type == SOCK_STREAM || type == SOCK_DGRAM)
        {
            int n;
            n =  ((type == SOCK_DGRAM) & 1) + (((domain == AF_UNIX) & 1) << 1);
            if((ch = io_open(*(ndevs+n), 0)) > 0)
            {
                if((fd = _socket_fd(ch, *(ndevs+n))) == -1)
                {
                    io_close(ch);
                }
           
            }
        }
    }
    if(fd < 0) errno = ENETDOWN;
    return fd;
}

