#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <ctype.h>
#include <sys/time.h>
#include <sys/types.h>
#include <errno.h>

# include <sys/socket.h>
# include <netinet/in.h>
# include <netdb.h>
# include <arpa/inet.h>

/*---------------------------------------------------------------.
| Really only for QDOS, but as I claim the same program compiles |
|  identically on QDOS and Unix, it is not #defined              |
`---------------------------------------------------------------*/
char _prog_name[] = "Broadcast";

static void display_inet(struct sockaddr_in *s)
{
    char *s1;
    if((s1 = inet_ntoa(s->sin_addr)))
    {
        long n;
        inet_aton(s1, (struct in_addr *)&n);
        n = ntohl(n);
        printf ("Address = %s:%d (%x)", s1, htons(s->sin_port),n);
    }
}

int main (int ac, char **av)
{
    struct sockaddr_in name;
    int sz, sock, c, n, port=7, one = 1;
    char buf[128], **q;
    short done = 0;             
    struct hostent *h;
    fd_set rfds;
    struct timeval tv;
    time_t t;

    *buf = 0;
    while((c = getopt(ac, av,"h:p:")) != EOF)
    {
        switch(c)
        {
            case 'p':
                port = atoi(optarg);
                break;
            case 'h':
                strcpy(buf, optarg);
                done = 1;
                break;
        }
    }

    
    name.sin_family = AF_INET;
    name.sin_port = htons(port);
    
    if ((sock = socket (AF_INET, SOCK_DGRAM, 0)) != -1)
    {
        sz = sizeof(name);
        
        n = setsockopt(sock, SOL_SOCKET, SO_BROADCAST, &one,
                       sizeof(int));
        if(n < 0) perror("Set Broadcast");
            

        if(*buf == 0)
        {
            gethostname(buf, sizeof(buf)-1);
        }
        

        {
            unsigned long bro;
            
            if((h = gethostbyname(buf)) == NULL)
            {
                perror("gethost");exit(0);
            }
            
            
            name.sin_addr = *((struct in_addr *) h->h_addr);
            bro = ntohl(name.sin_addr.s_addr);

            printf("in host fmt %08x\n", bro);
            printf("Len = %d\n", h->h_length);
            printf("Adr = %d\n", h->h_addrtype);            
            printf("h0 = %x\n", h->h_addr_list);                        
            printf("h[0] = %x\n", h->h_addr_list[0]);
            printf("h[1] = %x\n", h->h_addr_list[1]);                                    

            {
                int i,*q;
                for(i = 0; q = (int *)(h->h_addr_list[i]); i++)
                {
                    n = ntohl(*q);
                    printf("IP   : %08x %08x\n", q,n);
                }
            }
            
            printf("Host : %s\n", h->h_name);
            
            for(q = h->h_aliases; *q; q++)
            {
                printf("Alias: %s\n", *q);
            }

            if(done) exit(0);
            
            if(IN_CLASSA(bro))
            {
                bro = bro | ~IN_CLASSA_NET;
            }
            else if(IN_CLASSB(bro))
            {
                bro = bro | ~IN_CLASSB_NET;
            }
            else if(IN_CLASSC(bro))
            {
                bro = bro | ~IN_CLASSC_NET;
            }
            name.sin_addr.s_addr = htonl(bro);
            printf("Using broadcast of %x\n", name.sin_addr.s_addr);
        }
        
        n = sendto(sock, "hello", 5, 0, (struct sockaddr *)&name, sz);
        printf("sendto %d bytes\n", n);
        
        FD_ZERO(&rfds);

        t = time(NULL), printf("Start %s", ctime(&t));

        tv.tv_sec = 2;
        tv.tv_usec = 0;
        
        for(done = 0; !done;)
        {
            FD_SET(sock, &rfds);
            n = select(FD_SETSIZE, &rfds, NULL, NULL, &tv);
            if(n > 0)
            {
                sz = sizeof(name);
                if((n = recvfrom (sock, buf, sizeof(buf),
                              0, (struct sockaddr *)&name, &sz)) > 0)
                {
                    printf("%d bytes from ", n);
                    display_inet(&name);
                    printf(" with %ld.%06ld left\n",
                           tv.tv_sec, tv.tv_usec*50/1000000);
                }
                else
                {
                    perror("recvfrom");
                    done = 1;
                }
            } 
            else
            {
                printf("non +ve from select, %d %d\n", n, errno);
                done = 1;
            }
        }
        t = time(NULL), printf("End %s", ctime(&t));
        close(sock);
    }		    
    return 0;
}

